Merge branch 'maint-1.5.6' into maint-1.6.0
[git.git] / git-rebase--interactive.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2006 Johannes E. Schindelin
4
5 # SHORT DESCRIPTION
6 #
7 # This script makes it easy to fix up commits in the middle of a series,
8 # and rearrange commits.
9 #
10 # The original idea comes from Eric W. Biederman, in
11 # http://article.gmane.org/gmane.comp.version-control.git/22407
12
13 OPTIONS_KEEPDASHDASH=
14 OPTIONS_SPEC="\
15 git-rebase [-i] [options] [--] <upstream> [<branch>]
16 git-rebase [-i] (--continue | --abort | --skip)
17 --
18  Available options are
19 v,verbose          display a diffstat of what changed upstream
20 onto=              rebase onto given branch instead of upstream
21 p,preserve-merges  try to recreate merges instead of ignoring them
22 s,strategy=        use the given merge strategy
23 m,merge            always used (no-op)
24 i,interactive      always used (no-op)
25  Actions:
26 continue           continue rebasing process
27 abort              abort rebasing process and restore original branch
28 skip               skip current patch and continue rebasing process
29 "
30
31 . git-sh-setup
32 require_work_tree
33
34 DOTEST="$GIT_DIR/rebase-merge"
35 TODO="$DOTEST"/git-rebase-todo
36 DONE="$DOTEST"/done
37 MSG="$DOTEST"/message
38 SQUASH_MSG="$DOTEST"/message-squash
39 REWRITTEN="$DOTEST"/rewritten
40 PRESERVE_MERGES=
41 STRATEGY=
42 ONTO=
43 VERBOSE=
44
45 GIT_CHERRY_PICK_HELP="  After resolving the conflicts,
46 mark the corrected paths with 'git add <paths>', and
47 run 'git rebase --continue'"
48 export GIT_CHERRY_PICK_HELP
49
50 warn () {
51         echo "$*" >&2
52 }
53
54 output () {
55         case "$VERBOSE" in
56         '')
57                 output=$("$@" 2>&1 )
58                 status=$?
59                 test $status != 0 && printf "%s\n" "$output"
60                 return $status
61                 ;;
62         *)
63                 "$@"
64                 ;;
65         esac
66 }
67
68 run_pre_rebase_hook () {
69         if test -x "$GIT_DIR/hooks/pre-rebase"
70         then
71                 "$GIT_DIR/hooks/pre-rebase" ${1+"$@"} || {
72                         echo >&2 "The pre-rebase hook refused to rebase."
73                         exit 1
74                 }
75         fi
76 }
77
78 require_clean_work_tree () {
79         # test if working tree is dirty
80         git rev-parse --verify HEAD > /dev/null &&
81         git update-index --ignore-submodules --refresh &&
82         git diff-files --quiet --ignore-submodules &&
83         git diff-index --cached --quiet HEAD --ignore-submodules -- ||
84         die "Working tree is dirty"
85 }
86
87 ORIG_REFLOG_ACTION="$GIT_REFLOG_ACTION"
88
89 comment_for_reflog () {
90         case "$ORIG_REFLOG_ACTION" in
91         ''|rebase*)
92                 GIT_REFLOG_ACTION="rebase -i ($1)"
93                 export GIT_REFLOG_ACTION
94                 ;;
95         esac
96 }
97
98 last_count=
99 mark_action_done () {
100         sed -e 1q < "$TODO" >> "$DONE"
101         sed -e 1d < "$TODO" >> "$TODO".new
102         mv -f "$TODO".new "$TODO"
103         count=$(grep -c '^[^#]' < "$DONE")
104         total=$(($count+$(grep -c '^[^#]' < "$TODO")))
105         if test "$last_count" != "$count"
106         then
107                 last_count=$count
108                 printf "Rebasing (%d/%d)\r" $count $total
109                 test -z "$VERBOSE" || echo
110         fi
111 }
112
113 make_patch () {
114         parent_sha1=$(git rev-parse --verify "$1"^) ||
115                 die "Cannot get patch for $1^"
116         git diff-tree -p "$parent_sha1".."$1" > "$DOTEST"/patch
117         test -f "$DOTEST"/message ||
118                 git cat-file commit "$1" | sed "1,/^$/d" > "$DOTEST"/message
119         test -f "$DOTEST"/author-script ||
120                 get_author_ident_from_commit "$1" > "$DOTEST"/author-script
121 }
122
123 die_with_patch () {
124         make_patch "$1"
125         git rerere
126         die "$2"
127 }
128
129 die_abort () {
130         rm -rf "$DOTEST"
131         die "$1"
132 }
133
134 has_action () {
135         grep '^[^#]' "$1" >/dev/null
136 }
137
138 pick_one () {
139         no_ff=
140         case "$1" in -n) sha1=$2; no_ff=t ;; *) sha1=$1 ;; esac
141         output git rev-parse --verify $sha1 || die "Invalid commit name: $sha1"
142         test -d "$REWRITTEN" &&
143                 pick_one_preserving_merges "$@" && return
144         parent_sha1=$(git rev-parse --verify $sha1^) ||
145                 die "Could not get the parent of $sha1"
146         current_sha1=$(git rev-parse --verify HEAD)
147         if test "$no_ff$current_sha1" = "$parent_sha1"; then
148                 output git reset --hard $sha1
149                 test "a$1" = a-n && output git reset --soft $current_sha1
150                 sha1=$(git rev-parse --short $sha1)
151                 output warn Fast forward to $sha1
152         else
153                 output git cherry-pick "$@"
154         fi
155 }
156
157 pick_one_preserving_merges () {
158         fast_forward=t
159         case "$1" in
160         -n)
161                 fast_forward=f
162                 sha1=$2
163                 ;;
164         *)
165                 sha1=$1
166                 ;;
167         esac
168         sha1=$(git rev-parse $sha1)
169
170         if test -f "$DOTEST"/current-commit
171         then
172                 current_commit=$(cat "$DOTEST"/current-commit) &&
173                 git rev-parse HEAD > "$REWRITTEN"/$current_commit &&
174                 rm "$DOTEST"/current-commit ||
175                 die "Cannot write current commit's replacement sha1"
176         fi
177
178         echo $sha1 > "$DOTEST"/current-commit
179
180         # rewrite parents; if none were rewritten, we can fast-forward.
181         new_parents=
182         for p in $(git rev-list --parents -1 $sha1 | cut -d' ' -f2-)
183         do
184                 if test -f "$REWRITTEN"/$p
185                 then
186                         new_p=$(cat "$REWRITTEN"/$p)
187                         test $p != $new_p && fast_forward=f
188                         case "$new_parents" in
189                         *$new_p*)
190                                 ;; # do nothing; that parent is already there
191                         *)
192                                 new_parents="$new_parents $new_p"
193                                 ;;
194                         esac
195                 else
196                         new_parents="$new_parents $p"
197                 fi
198         done
199         case $fast_forward in
200         t)
201                 output warn "Fast forward to $sha1"
202                 output git reset --hard $sha1 ||
203                         die "Cannot fast forward to $sha1"
204                 ;;
205         f)
206                 test "a$1" = a-n && die "Refusing to squash a merge: $sha1"
207
208                 first_parent=$(expr "$new_parents" : ' \([^ ]*\)')
209                 # detach HEAD to current parent
210                 output git checkout $first_parent 2> /dev/null ||
211                         die "Cannot move HEAD to $first_parent"
212
213                 case "$new_parents" in
214                 ' '*' '*)
215                         # redo merge
216                         author_script=$(get_author_ident_from_commit $sha1)
217                         eval "$author_script"
218                         msg="$(git cat-file commit $sha1 | sed -e '1,/^$/d')"
219                         # No point in merging the first parent, that's HEAD
220                         new_parents=${new_parents# $first_parent}
221                         if ! GIT_AUTHOR_NAME="$GIT_AUTHOR_NAME" \
222                                 GIT_AUTHOR_EMAIL="$GIT_AUTHOR_EMAIL" \
223                                 GIT_AUTHOR_DATE="$GIT_AUTHOR_DATE" \
224                                 output git merge $STRATEGY -m "$msg" \
225                                         $new_parents
226                         then
227                                 git rerere
228                                 printf "%s\n" "$msg" > "$GIT_DIR"/MERGE_MSG
229                                 die Error redoing merge $sha1
230                         fi
231                         ;;
232                 *)
233                         output git cherry-pick "$@" ||
234                                 die_with_patch $sha1 "Could not pick $sha1"
235                         ;;
236                 esac
237                 ;;
238         esac
239 }
240
241 nth_string () {
242         case "$1" in
243         *1[0-9]|*[04-9]) echo "$1"th;;
244         *1) echo "$1"st;;
245         *2) echo "$1"nd;;
246         *3) echo "$1"rd;;
247         esac
248 }
249
250 make_squash_message () {
251         if test -f "$SQUASH_MSG"; then
252                 COUNT=$(($(sed -n "s/^# This is [^0-9]*\([1-9][0-9]*\).*/\1/p" \
253                         < "$SQUASH_MSG" | sed -ne '$p')+1))
254                 echo "# This is a combination of $COUNT commits."
255                 sed -e 1d -e '2,/^./{
256                         /^$/d
257                 }' <"$SQUASH_MSG"
258         else
259                 COUNT=2
260                 echo "# This is a combination of two commits."
261                 echo "# The first commit's message is:"
262                 echo
263                 git cat-file commit HEAD | sed -e '1,/^$/d'
264         fi
265         echo
266         echo "# This is the $(nth_string $COUNT) commit message:"
267         echo
268         git cat-file commit $1 | sed -e '1,/^$/d'
269 }
270
271 peek_next_command () {
272         sed -n "1s/ .*$//p" < "$TODO"
273 }
274
275 do_next () {
276         rm -f "$DOTEST"/message "$DOTEST"/author-script \
277                 "$DOTEST"/amend || exit
278         read command sha1 rest < "$TODO"
279         case "$command" in
280         '#'*|''|noop)
281                 mark_action_done
282                 ;;
283         pick|p)
284                 comment_for_reflog pick
285
286                 mark_action_done
287                 pick_one $sha1 ||
288                         die_with_patch $sha1 "Could not apply $sha1... $rest"
289                 ;;
290         edit|e)
291                 comment_for_reflog edit
292
293                 mark_action_done
294                 pick_one $sha1 ||
295                         die_with_patch $sha1 "Could not apply $sha1... $rest"
296                 make_patch $sha1
297                 git rev-parse --verify HEAD > "$DOTEST"/amend
298                 warn "Stopped at $sha1... $rest"
299                 warn "You can amend the commit now, with"
300                 warn
301                 warn "  git commit --amend"
302                 warn
303                 warn "Once you are satisfied with your changes, run"
304                 warn
305                 warn "  git rebase --continue"
306                 warn
307                 exit 0
308                 ;;
309         squash|s)
310                 comment_for_reflog squash
311
312                 test -f "$DONE" && has_action "$DONE" ||
313                         die "Cannot 'squash' without a previous commit"
314
315                 mark_action_done
316                 make_squash_message $sha1 > "$MSG"
317                 failed=f
318                 author_script=$(get_author_ident_from_commit HEAD)
319                 output git reset --soft HEAD^
320                 pick_one -n $sha1 || failed=t
321                 case "$(peek_next_command)" in
322                 squash|s)
323                         EDIT_COMMIT=
324                         USE_OUTPUT=output
325                         MSG_OPT=-F
326                         MSG_FILE="$MSG"
327                         cp "$MSG" "$SQUASH_MSG"
328                         ;;
329                 *)
330                         EDIT_COMMIT=-e
331                         USE_OUTPUT=
332                         MSG_OPT=
333                         MSG_FILE=
334                         rm -f "$SQUASH_MSG" || exit
335                         cp "$MSG" "$GIT_DIR"/SQUASH_MSG
336                         rm -f "$GIT_DIR"/MERGE_MSG || exit
337                         ;;
338                 esac
339                 echo "$author_script" > "$DOTEST"/author-script
340                 if test $failed = f
341                 then
342                         # This is like --amend, but with a different message
343                         eval "$author_script"
344                         GIT_AUTHOR_NAME="$GIT_AUTHOR_NAME" \
345                         GIT_AUTHOR_EMAIL="$GIT_AUTHOR_EMAIL" \
346                         GIT_AUTHOR_DATE="$GIT_AUTHOR_DATE" \
347                         $USE_OUTPUT git commit --no-verify $MSG_OPT "$MSG_FILE" $EDIT_COMMIT || failed=t
348                 fi
349                 if test $failed = t
350                 then
351                         cp "$MSG" "$GIT_DIR"/MERGE_MSG
352                         warn
353                         warn "Could not apply $sha1... $rest"
354                         die_with_patch $sha1 ""
355                 fi
356                 ;;
357         *)
358                 warn "Unknown command: $command $sha1 $rest"
359                 die_with_patch $sha1 "Please fix this in the file $TODO."
360                 ;;
361         esac
362         test -s "$TODO" && return
363
364         comment_for_reflog finish &&
365         HEADNAME=$(cat "$DOTEST"/head-name) &&
366         OLDHEAD=$(cat "$DOTEST"/head) &&
367         SHORTONTO=$(git rev-parse --short $(cat "$DOTEST"/onto)) &&
368         if test -d "$REWRITTEN"
369         then
370                 test -f "$DOTEST"/current-commit &&
371                         current_commit=$(cat "$DOTEST"/current-commit) &&
372                         git rev-parse HEAD > "$REWRITTEN"/$current_commit
373                 if test -f "$REWRITTEN"/$OLDHEAD
374                 then
375                         NEWHEAD=$(cat "$REWRITTEN"/$OLDHEAD)
376                 else
377                         NEWHEAD=$OLDHEAD
378                 fi
379         else
380                 NEWHEAD=$(git rev-parse HEAD)
381         fi &&
382         case $HEADNAME in
383         refs/*)
384                 message="$GIT_REFLOG_ACTION: $HEADNAME onto $SHORTONTO)" &&
385                 git update-ref -m "$message" $HEADNAME $NEWHEAD $OLDHEAD &&
386                 git symbolic-ref HEAD $HEADNAME
387                 ;;
388         esac && {
389                 test ! -f "$DOTEST"/verbose ||
390                         git diff-tree --stat $(cat "$DOTEST"/head)..HEAD
391         } &&
392         rm -rf "$DOTEST" &&
393         git gc --auto &&
394         warn "Successfully rebased and updated $HEADNAME."
395
396         exit
397 }
398
399 do_rest () {
400         while :
401         do
402                 do_next
403         done
404 }
405
406 # check if no other options are set
407 is_standalone () {
408         test $# -eq 2 -a "$2" = '--' &&
409         test -z "$ONTO" &&
410         test -z "$PRESERVE_MERGES" &&
411         test -z "$STRATEGY" &&
412         test -z "$VERBOSE"
413 }
414
415 get_saved_options () {
416         test -d "$REWRITTEN" && PRESERVE_MERGES=t
417         test -f "$DOTEST"/strategy && STRATEGY="$(cat "$DOTEST"/strategy)"
418         test -f "$DOTEST"/verbose && VERBOSE=t
419 }
420
421 while test $# != 0
422 do
423         case "$1" in
424         --continue)
425                 is_standalone "$@" || usage
426                 get_saved_options
427                 comment_for_reflog continue
428
429                 test -d "$DOTEST" || die "No interactive rebase running"
430
431                 # Sanity check
432                 git rev-parse --verify HEAD >/dev/null ||
433                         die "Cannot read HEAD"
434                 git update-index --ignore-submodules --refresh &&
435                         git diff-files --quiet --ignore-submodules ||
436                         die "Working tree is dirty"
437
438                 # do we have anything to commit?
439                 if git diff-index --cached --quiet --ignore-submodules HEAD --
440                 then
441                         : Nothing to commit -- skip this
442                 else
443                         . "$DOTEST"/author-script ||
444                                 die "Cannot find the author identity"
445                         amend=
446                         if test -f "$DOTEST"/amend
447                         then
448                                 amend=$(git rev-parse --verify HEAD)
449                                 test "$amend" = $(cat "$DOTEST"/amend) ||
450                                 die "\
451 You have uncommitted changes in your working tree. Please, commit them
452 first and then run 'git rebase --continue' again."
453                                 git reset --soft HEAD^ ||
454                                 die "Cannot rewind the HEAD"
455                         fi
456                         export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE &&
457                         git commit --no-verify -F "$DOTEST"/message -e || {
458                                 test -n "$amend" && git reset --soft $amend
459                                 die "Could not commit staged changes."
460                         }
461                 fi
462
463                 require_clean_work_tree
464                 do_rest
465                 ;;
466         --abort)
467                 is_standalone "$@" || usage
468                 get_saved_options
469                 comment_for_reflog abort
470
471                 git rerere clear
472                 test -d "$DOTEST" || die "No interactive rebase running"
473
474                 HEADNAME=$(cat "$DOTEST"/head-name)
475                 HEAD=$(cat "$DOTEST"/head)
476                 case $HEADNAME in
477                 refs/*)
478                         git symbolic-ref HEAD $HEADNAME
479                         ;;
480                 esac &&
481                 output git reset --hard $HEAD &&
482                 rm -rf "$DOTEST"
483                 exit
484                 ;;
485         --skip)
486                 is_standalone "$@" || usage
487                 get_saved_options
488                 comment_for_reflog skip
489
490                 git rerere clear
491                 test -d "$DOTEST" || die "No interactive rebase running"
492
493                 output git reset --hard && do_rest
494                 ;;
495         -s)
496                 case "$#,$1" in
497                 *,*=*)
498                         STRATEGY="-s "$(expr "z$1" : 'z-[^=]*=\(.*\)') ;;
499                 1,*)
500                         usage ;;
501                 *)
502                         STRATEGY="-s $2"
503                         shift ;;
504                 esac
505                 ;;
506         -m)
507                 # we use merge anyway
508                 ;;
509         -v)
510                 VERBOSE=t
511                 ;;
512         -p)
513                 PRESERVE_MERGES=t
514                 ;;
515         -i)
516                 # yeah, we know
517                 ;;
518         --onto)
519                 shift
520                 ONTO=$(git rev-parse --verify "$1") ||
521                         die "Does not point to a valid commit: $1"
522                 ;;
523         --)
524                 shift
525                 run_pre_rebase_hook ${1+"$@"}
526                 test $# -eq 1 -o $# -eq 2 || usage
527                 test -d "$DOTEST" &&
528                         die "Interactive rebase already started"
529
530                 git var GIT_COMMITTER_IDENT >/dev/null ||
531                         die "You need to set your committer info first"
532
533                 comment_for_reflog start
534
535                 require_clean_work_tree
536
537                 UPSTREAM=$(git rev-parse --verify "$1") || die "Invalid base"
538                 test -z "$ONTO" && ONTO=$UPSTREAM
539
540                 if test ! -z "$2"
541                 then
542                         output git show-ref --verify --quiet "refs/heads/$2" ||
543                                 die "Invalid branchname: $2"
544                         output git checkout "$2" ||
545                                 die "Could not checkout $2"
546                 fi
547
548                 HEAD=$(git rev-parse --verify HEAD) || die "No HEAD?"
549                 mkdir "$DOTEST" || die "Could not create temporary $DOTEST"
550
551                 : > "$DOTEST"/interactive || die "Could not mark as interactive"
552                 git symbolic-ref HEAD > "$DOTEST"/head-name 2> /dev/null ||
553                         echo "detached HEAD" > "$DOTEST"/head-name
554
555                 echo $HEAD > "$DOTEST"/head
556                 echo $UPSTREAM > "$DOTEST"/upstream
557                 echo $ONTO > "$DOTEST"/onto
558                 test -z "$STRATEGY" || echo "$STRATEGY" > "$DOTEST"/strategy
559                 test t = "$VERBOSE" && : > "$DOTEST"/verbose
560                 if test t = "$PRESERVE_MERGES"
561                 then
562                         # $REWRITTEN contains files for each commit that is
563                         # reachable by at least one merge base of $HEAD and
564                         # $UPSTREAM. They are not necessarily rewritten, but
565                         # their children might be.
566                         # This ensures that commits on merged, but otherwise
567                         # unrelated side branches are left alone. (Think "X"
568                         # in the man page's example.)
569                         mkdir "$REWRITTEN" &&
570                         for c in $(git merge-base --all $HEAD $UPSTREAM)
571                         do
572                                 echo $ONTO > "$REWRITTEN"/$c ||
573                                         die "Could not init rewritten commits"
574                         done
575                         MERGES_OPTION=
576                 else
577                         MERGES_OPTION=--no-merges
578                 fi
579
580                 SHORTUPSTREAM=$(git rev-parse --short $UPSTREAM)
581                 SHORTHEAD=$(git rev-parse --short $HEAD)
582                 SHORTONTO=$(git rev-parse --short $ONTO)
583                 git rev-list $MERGES_OPTION --pretty=oneline --abbrev-commit \
584                         --abbrev=7 --reverse --left-right --cherry-pick \
585                         $UPSTREAM...$HEAD | \
586                         sed -n "s/^>/pick /p" > "$TODO"
587                 test -s "$TODO" || echo noop >> "$TODO"
588                 cat >> "$TODO" << EOF
589
590 # Rebase $SHORTUPSTREAM..$SHORTHEAD onto $SHORTONTO
591 #
592 # Commands:
593 #  p, pick = use commit
594 #  e, edit = use commit, but stop for amending
595 #  s, squash = use commit, but meld into previous commit
596 #
597 # If you remove a line here THAT COMMIT WILL BE LOST.
598 # However, if you remove everything, the rebase will be aborted.
599 #
600 EOF
601
602                 has_action "$TODO" ||
603                         die_abort "Nothing to do"
604
605                 cp "$TODO" "$TODO".backup
606                 git_editor "$TODO" ||
607                         die "Could not execute editor"
608
609                 has_action "$TODO" ||
610                         die_abort "Nothing to do"
611
612                 git update-ref ORIG_HEAD $HEAD
613                 output git checkout $ONTO && do_rest
614                 ;;
615         esac
616         shift
617 done